<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryPeriodDay ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryPeriodDay extends AbstractStructArrayBase
{
    /**
     * The WSEntryPeriodDay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryPeriodDay[]
     */
    public $WSEntryPeriodDay;
    /**
     * Constructor method for ArrayOfWSEntryPeriodDay
     * @uses ArrayOfWSEntryPeriodDay::setWSEntryPeriodDay()
     * @param \StructType\WSEntryPeriodDay[] $wSEntryPeriodDay
     */
    public function __construct(array $wSEntryPeriodDay = array())
    {
        $this
            ->setWSEntryPeriodDay($wSEntryPeriodDay);
    }
    /**
     * Get WSEntryPeriodDay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryPeriodDay[]|null
     */
    public function getWSEntryPeriodDay()
    {
        return isset($this->WSEntryPeriodDay) ? $this->WSEntryPeriodDay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryPeriodDay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryPeriodDay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryPeriodDayForArrayConstraintsFromSetWSEntryPeriodDay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryPeriodDayWSEntryPeriodDayItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryPeriodDayWSEntryPeriodDayItem instanceof \StructType\WSEntryPeriodDay) {
                $invalidValues[] = is_object($arrayOfWSEntryPeriodDayWSEntryPeriodDayItem) ? get_class($arrayOfWSEntryPeriodDayWSEntryPeriodDayItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryPeriodDayWSEntryPeriodDayItem), var_export($arrayOfWSEntryPeriodDayWSEntryPeriodDayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryPeriodDay property can only contain items of type \StructType\WSEntryPeriodDay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryPeriodDay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryPeriodDay[] $wSEntryPeriodDay
     * @return \ArrayType\ArrayOfWSEntryPeriodDay
     */
    public function setWSEntryPeriodDay(array $wSEntryPeriodDay = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryPeriodDayArrayErrorMessage = self::validateWSEntryPeriodDayForArrayConstraintsFromSetWSEntryPeriodDay($wSEntryPeriodDay))) {
            throw new \InvalidArgumentException($wSEntryPeriodDayArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryPeriodDay) || (is_array($wSEntryPeriodDay) && empty($wSEntryPeriodDay))) {
            unset($this->WSEntryPeriodDay);
        } else {
            $this->WSEntryPeriodDay = $wSEntryPeriodDay;
        }
        return $this;
    }
    /**
     * Add item to WSEntryPeriodDay value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryPeriodDay $item
     * @return \ArrayType\ArrayOfWSEntryPeriodDay
     */
    public function addToWSEntryPeriodDay(\StructType\WSEntryPeriodDay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryPeriodDay) {
            throw new \InvalidArgumentException(sprintf('The WSEntryPeriodDay property can only contain items of type \StructType\WSEntryPeriodDay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryPeriodDay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryPeriodDay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryPeriodDay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryPeriodDay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryPeriodDay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryPeriodDay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryPeriodDay
     */
    public function getAttributeName()
    {
        return 'WSEntryPeriodDay';
    }
}
